import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import { LayoutBlockVariation } from './layout-block-variation.enum';
import { LayoutBlockContainer } from './layout-block-container.enum';
import readme from './readme.md';

<Meta title="Layout/digi-layout-block" />

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Standard

This is the standard layout block. it has a primary background color and an inner container (using `digi-layout-container`).

<Canvas>
  <Story name="Standard">
    /* html */
    {`
      <digi-layout-block>
        <digi-typography>
          <h2>I am a standard layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

## Variations

The component has a few variations. This controls the look of the component. The variation names map directly to the different background modifiers. Typescript users should import and use `LayoutBlockVariation` to set variation.

### Primary

The primary variation uses the primary background color. This is the default, so it should look just like the standard version.

<Canvas>
  <Story name="Variation - Primary">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.PRIMARY}"
      >
        <digi-typography>
          <h2>I am a primary layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### Secondary

The secondary variation uses the secondary background color.

<Canvas>
  <Story name="Variation - Secondary">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.SECONDARY}"
      >
        <digi-typography>
          <h2>I am a secondary layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--typography--margin--text); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### Tertiary

The tertiary variation uses the tertiary background color.

<Canvas>
  <Story name="Variation - Tertiary">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.TERTIARY}"
      >
        <digi-typography>
          <h2>I am a tertiary layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### Symbol

The symbol variation uses the symbol background color.

<Canvas>
  <Story name="Variation - Symbol">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.SYMBOL}"
      >
        <digi-typography>
          <h2>I am a symbol layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### Profile

The profile variation uses the profile background color.

<Canvas>
  <Story name="Variation - Profile">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.PROFILE}"
      >
        <digi-typography style="--digi--typography--color--text: #fff;">
          <h2>I am a profile layout block.</h2>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

## Containers

The component can have different kinds of inner containers (using `digi-layout-container`), or no inner container at all. Typescript users should import and use `LayoutBlockContainer` to set container.

### Static

This sets a static inner container. This is the default so it should behave just like the standard version.

<Canvas>
  <Story name="Container - Static">
    /* html */
    {`
      <digi-layout-block
        af-container="${LayoutBlockContainer.STATIC}"
      >
        <digi-typography>
          <h2>I have a static inner container</h2>
          <p>My content will never be wider than the container allows</p>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### Fluid

This sets a fluid inner container. This creates a full width container with gutters on the sides.

<Canvas>
  <Story name="Container - Fluid">
    /* html */
    {`
      <digi-layout-block
        af-container="${LayoutBlockContainer.FLUID}"
      >
        <digi-typography>
          <h2>I have a fluid inner container</h2>
          <p>My content can stretch across the entire width, but I still have gutters on the sides.</p>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

### None

This removes the inner container completely.

<Canvas>
  <Story name="Container - None">
    /* html */
    {`
      <digi-layout-block
        af-container="${LayoutBlockContainer.NONE}"
      >
        <digi-typography>
          <h2>I have no inner container</h2>
          <p>My content can stretch across the entire width, and I have no gutters on the sides at all.</p>
          <digi-media-image
            af-src="https://picsum.photos/id/237/1280/500"
            af-alt="En bild"
            af-width="1280"
            af-height="500"
            style="margin-bottom: var(--digi--margin--medium); display: block;"
          ></digi-media-image>
          <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
        </digi-typography>
      </digi-layout-block>
    `}
  </Story>
</Canvas>

## Many blocks in a column

This is what it can look like with many blocks in a column. Here we are using some utility classes to add top and bottom padding to the inner content.

<Canvas>
  <Story name="Many Blocks">
    /* html */
    {`
      <digi-layout-block
        af-variation="${LayoutBlockVariation.PRIMARY}"
      >
        <div class="digi--util--ptb--40">
          <digi-typography>
            <h2>I am the first block</h2>
            <p>Blocks are excellent for grouping different kinds of content in a page</p>
            <digi-media-image
              af-src="https://picsum.photos/id/235/1280/500"
              af-alt="En bild"
              af-width="1280"
              af-height="500"
              style="margin-bottom: var(--digi--margin--medium); display: block;"
            ></digi-media-image>
          </digi-typography>
        </div>
      </digi-layout-block>
      <digi-layout-block
        af-variation="${LayoutBlockVariation.SECONDARY}"
      >
        <div class="digi--util--ptb--40">
          <digi-typography>
            <h2>Like this, you see?</h2>
            <p>And if you alternate block variations, you get more visible grouping of information</p>
            <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
          </digi-typography>
        </div>
      </digi-layout-block>
      <digi-layout-block
        af-variation="${LayoutBlockVariation.PRIMARY}"
      >
        <div class="digi--util--ptb--40">
          <digi-typography>
            <h2>And then there's more</h2>
            <p>This can really go on forever if you wish :)</p>
            <digi-media-image
              af-src="https://picsum.photos/id/230/1280/500"
              af-alt="En bild"
              af-width="1280"
              af-height="500"
              style="margin-bottom: var(--digi--typography--margin--text); display: block;"
            ></digi-media-image>
          </digi-typography>
        </div>
      </digi-layout-block>
      <digi-layout-block
        af-variation="${LayoutBlockVariation.SYMBOL}"
      >
        <div class="digi--util--ptb--40">
          <digi-typography>
            <h2>I am truly a dark looking block.</h2>
            <p>And like this we build a page.</p>
            <digi-media-image
              af-src="https://picsum.photos/id/225/1280/500"
              af-alt="En bild"
              af-width="1280"
              af-height="500"
              style="margin-bottom: var(--digi--typography--margin--text); display: block;"
            ></digi-media-image>
            <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam magna neque, interdum vel massa eget, condimentum rutrum velit. Sed vitae ullamcorper sem. Aliquam malesuada nunc sed purus mollis scelerisque. Curabitur bibendum leo quis ante porttitor tincidunt. Nam tincidunt imperdiet tortor eu suscipit. Maecenas ut dui est. Pellentesque in magna molestie, vulputate nibh non, ullamcorper magna. Donec ullamcorper vehicula orci, sit amet ultrices tellus finibus non. Curabitur varius consequat est, ut eleifend urna ornare vel. Aliquam efficitur dictum consectetur. Suspendisse vehicula, velit fringilla faucibus euismod, nisl dolor rutrum nisi, ut consequat neque magna sit amet nunc. Donec porttitor gravida diam ut iaculis. Proin cursus elementum faucibus. Ut eu tincidunt sem. Donec velit massa, bibendum in turpis eu, ornare consectetur risus. Vestibulum in ipsum nibh. </p>
          </digi-typography>
        </div>
      </digi-layout-block>
    `}
  </Story>
</Canvas>
